#include "MainWindow.h"
#include "ui_MainWindow.h"

#include <QtWidgets/QMessageBox>

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow) {
    setupUi();
}
MainWindow::~MainWindow() {
    delete ui;
}

void MainWindow::setupUi() {
    ui->setupUi(this);

    //region Shortcuts
    ui->actionFileNew->setShortcut(QKeySequence::New);
    ui->actionFileOpen->setShortcut(QKeySequence::Open);
    ui->actionFileSave->setShortcut(QKeySequence::Save);
    ui->actionFileSaveAs->setShortcut(QKeySequence::SaveAs);
    ui->actionFileReload->setShortcut(QKeySequence::Refresh);
    ui->actionFileClose->setShortcut(QKeySequence::Close);
    ui->actionFileSettings->setShortcut(QKeySequence::Preferences);
    ui->actionFileQuit->setShortcut(QKeySequence::Quit);

    ui->actionEditUndo->setShortcut(QKeySequence::Undo);
    ui->actionEditRedo->setShortcut(QKeySequence::Redo);
    ui->actionEditCopy->setShortcut(QKeySequence::Copy);
    ui->actionEditCut->setShortcut(QKeySequence::Cut);
    ui->actionEditPaste->setShortcut(QKeySequence::Paste);
    ui->actionEditModify->setShortcut(QKeySequence(tr("F2")));
    ui->actionEditDelete->setShortcut(QKeySequence::Delete);
    ui->actionEditMoveUp->setShortcut(QKeySequence(tr("Ctrl+Up")));
    ui->actionEditMoveDown->setShortcut(QKeySequence(tr("Ctrl+Down")));

    ui->actionSearchFind->setShortcut(QKeySequence::Find);
    ui->actionSearchFindNext->setShortcut(QKeySequence::FindNext);
    ui->actionSearchFindPrevious->setShortcut(QKeySequence::FindPrevious);
    ui->actionSearchReplace->setShortcut(QKeySequence::Replace);

    ui->actionHelpAboutNBTModifier->setShortcut(QKeySequence::HelpContents);
    //endregion

    //region Signals
    connect(ui->actionHelpAboutQt, &QAction::triggered, qApp, &QApplication::aboutQt);
    //endregion
}

void MainWindow::on_actionHelpAboutNBTModifier_triggered() {
    QMessageBox info(this);

    info.setIcon(QMessageBox::Information);
    info.setWindowTitle(tr("About NBTModifier"));

    info.setStandardButtons(QMessageBox::Ok);

    info.setTextFormat(Qt::RichText);
    info.setText(
        tr(
            // language=HTML
            "NBTModifier 1.0.0<br>"
            "Copyright © 2020 Julien Rosset<br>"
            "<br>"
            "<a href='https://www.qt.io/'>Qt %1</a> and <a href='https://github.com/KDE/breeze-icons'>KDE Breeze icons</a><br>"
            "<br>"
            "<a href='mailto:jul.rosset@gmail.com'>jul.rosset@gmail.com</a><br>"
            "<a href='https://git.jrosset.ovh/darkelfe14728/NBTModifier'>Project page</a>"
        )
            .arg(QT_VERSION_STR)
    );

    info.exec();
}